"{ Encoding: utf8 }" !
"{ Package: 'SpreadSheet:patch-simekf1-by-plickm1' }" !

!ExprBinOperator methodsFor:'recursion-detection'!

checkRecursionAgainst: anObject
   "sends message deeper"
   lnode checkRecursionAgainst: anObject.
   rnode checkRecursionAgainst: anObject.
! !

!CellReference methodsFor:'accessing'!

asString
        " e.g. : '<sheet name>'.C1 "
        ^ '''', sheet name, '''.',(col asAlphabet),(row asString).
! !

!ExprUnOperator methodsFor:'recursion-detection'!

checkRecursionAgainst: anObject
   "sends message deeper"
   node checkRecurstionAgainst: anObject.
! !

!CellReferenceRange methodsFor:'accessing'!

asString
        " e.g.: '<sheet name>'.C1:D3 "
        ^ '''', sheet name, '''.', (col asAlphabet),(row asString),':',(col2 asAlphabet),(row2 asString).
! !

!ExprFunction methodsFor:'recursion-detection'!

checkRecursionAgainst: anObject
   "sends message deeper"

   operands checkRecursionAgainst: anObject.
! !

!ExprFunction class methodsFor:'instance-creation'!

with: anOperand
   |tmp|
   tmp:= self new.
   tmp operands: anOperand.
   ^tmp.
! !

!ExpressionTests methodsFor:'testing'!

test05
        " tests the expressions' string representation "
        | sheet cell ref fun |

        " expressions with immediate values, test placement of parentheses
        around operands "
        cell := CellExpression new.
        cell root: (ExprBinPlus with: (ExprBinTimes with: 3 with: 2) with: 1).
        self assert: (cell stringRepr = '=3*2+1').

        cell root: (ExprBinTimes with: (ExprBinPlus with: 3 with: 2) with: (ExprUnNegation with: 1)).
        self assert: (cell stringRepr = '=(3+2)*(-1)').

        cell root: (ExprBinOver with: (ExprBinOver with: 1 with: 2) with: (ExprBinOver with: 3 with: 4)).
        self assert: (cell stringRepr = '=1/2/(3/4)').

        " expressions with references and functions "
        sheet := SpreadSheet new.
        sheet name: 'MySheet'.
        ref := CellReference new setReferenceRow:1 column:3 atSheet:sheet.
        cell root: ref.
        self assert: (cell stringRepr = '=''MySheet''.C1').


        cell root:
                (ExprFunSum new operands:
                        (CellReferenceRange new setReferenceFromR: 2 C: 1 toR: 5 C: 28 atSheet: sheet)
                 ).
        self assert: (cell stringRepr = '=sum(''MySheet''.A2:AB5)').

        cell root:
                (ExprBinPlus with: 3 with:
                        (ExprFunSum new operands:
                                (CellReferenceRange new setReferenceFromR: 1 C:1 toR: 3 C:3 atSheet: sheet)
                        )
                 ).
        self assert: (cell stringRepr = '=3+sum(''MySheet''.A1:C3)').

        cell root:
                (ExprBinPlus with:
                        (ExprFunSum new operands:
                                (CellReferenceRange new setReferenceFromR: 5 C:6 toR: 2 C:2 atSheet: sheet)
                        )
                 with: 5).
        self assert: (cell stringRepr = '=sum(''MySheet''.B2:F5)+5').

        fun := ExprFunSum new operands: (OrderedCollection with: 1 with: 'foo' with: 5 with: 0.1).
        self assert: (fun stringRepr = 'sum(1,foo,5,0.1)').
! !

!CellExpression methodsFor:'recursion-detection'!

checkRecursionAgainst: anObject
   "sends message deeper"
   root checkRecursionAgainst: anObject.
! !

!CellExpression class methodsFor:'instance-creation'!

with: anObject
  |tmp|
  tmp:=self new.
  tmp root: anObject.
  ^tmp.
! !

